//
//  uploadFileManager.m
//  隐私保护
//
//  Created by xd h on 2023/11/15.
//

#import "uploadFileManager.h"

@implementation uploadFileManager
static uploadFileManager * cur_uploadFileShareInstance = nil;
+(uploadFileManager *)shareInstance;
{
    static dispatch_once_t onceToken;
    
    dispatch_once(&onceToken, ^{
        cur_uploadFileShareInstance = [[uploadFileManager alloc] init];
        
    });
    
    return cur_uploadFileShareInstance;
}

- (id)init
{
    self = [super init];
    
    if (self) {
        //[self initManager];
    }
    
    return self;
}


//把TZAssetModel 转成 我们需要上传的model
- (NSMutableArray*)handlTZAssetModelToUploadFileDataFunBy:(NSMutableArray*)indexPathsForSelectedItems
{
    _fileModelDataArr = [NSMutableArray new];
    for (TZAssetModel * model in indexPathsForSelectedItems) {
        uploadFileDataModel * curModel = [uploadFileDataModel new];
        curModel.imageData = model.imageData;
        curModel.videoData = model.videoData;
        curModel.filename = [model.asset valueForKey:@"filename"];
        curModel.curUploadStateType = uploadStateWait;
        
        if(model.type == TZAssetModelMediaTypeVideo){
            curModel.curUploadFileType = uploadFileTypeVideo;
        }
        else{
            curModel.curUploadFileType = uploadFileTypeImage;
        }
        
        
        [_fileModelDataArr addObject:curModel];
        
        //保存到数据库
        curModel.bg_tableName = upLoadFile_image_tableName;
        [curModel bg_saveOrUpdateAsync:^(BOOL isSuccess) {
            HLog(@"%@ 写入 %@", curModel.filename, isSuccess ? @"成功":@"失败");
        }];
    }
    
    KWeakSelf
    if(_fileModelDataArr.count > 0){
        
        //骚操作 重新查出来 拿到bg_id
        [uploadFileDataModel bg_findAsync:upLoadFile_image_tableName limit:_fileModelDataArr.count orderBy:nil desc:YES complete:^(NSArray * _Nullable array) {
            
            for (int i=0; i<array.count; i++) {
                uploadFileDataModel *bg_mod  = array[i];
                
                for (uploadFileDataModel *data_mod in _fileModelDataArr) {
                    if([data_mod.filename isEqualToString:bg_mod.filename]){
                        data_mod.bg_id = bg_mod.bg_id;
                        //HLog(@"bg_id:%@",data_mod.bg_id);
                        break;
                    }
                }
            }
            
            [weakSelf beginUploadFileFun];
        }];
        
        
        //[self beginUploadFileFun];
    }
    
    return _fileModelDataArr;
}

- (void)beginUploadFileFun
{
    _isSuspendType = NO;
    
    _curUploadFileDataModel = _fileModelDataArr.firstObject;
    
    [[NSNotificationCenter defaultCenter] postNotificationName:uploadFileBeginNotification object:_curUploadFileDataModel];
}

//修改文件上传的状态
- (void)changeUploadFileState:(uploadStateType)curUploadStateType withDidUploadBytes:(long)didUpLoadBytes  complete:(custom_complete_B)complete
{
    _curUploadFileDataModel.curUploadStateType = curUploadStateType;
    _curUploadFileDataModel.didUploadBytes = didUpLoadBytes;
    
    if(!_isSuspendType){
        [[NSNotificationCenter defaultCenter] postNotificationName:uploadFileRefreshNotification object:_curUploadFileDataModel];
    }
    
    if(curUploadStateType == uploadStateUploading){
        return;
    }
   
    
    //NSNumber * numberUploadState = nil;
    NSString* where = nil;
    
//    if(curUploadStateType == uploadStateDone)
//    {//只有上传中的才可能是完成的
//        numberUploadState =  [NSNumber numberWithInt:uploadStateUploading];
//        where = [NSString stringWithFormat:@"where %@=%@ and %@=%@ ",bg_sqlKey(@"filename"),bg_sqlValue(_curUploadFileDataModel.filename),bg_sqlKey(@"curUploadStateType"),bg_sqlValue(numberUploadState)];
//    }
//    else
//    {//查找非上传完成的
//        numberUploadState =  [NSNumber numberWithInt:uploadStateDone];
//        where = [NSString stringWithFormat:@"where %@=%@ and %@!=%@ ",bg_sqlKey(@"filename"),bg_sqlValue(_curUploadFileDataModel.filename),bg_sqlKey(@"curUploadStateType"),bg_sqlValue(numberUploadState)];
//    }
    
    where = [NSString stringWithFormat:@"where %@=%@ ",bg_sqlKey(@"bg_id"),bg_sqlValue(_curUploadFileDataModel.bg_id)];
    //HLog(@"ffff:%@",_curUploadFileDataModel.bg_id);
    
    [uploadFileDataModel bg_findAsync:upLoadFile_image_tableName where:where complete:^(NSArray * _Nullable array) {
        for (uploadFileDataModel * curModel in array) {
            curModel.curUploadStateType = curUploadStateType;
            curModel.didUploadBytes = didUpLoadBytes;
            
            if(curUploadStateType == uploadStateDone){
                curModel.videoData = [NSData new];
                HLog(@"");
            }
            
            [curModel bg_saveOrUpdateAsync:^(BOOL isSuccess) {
                HLog(@"%@ 写入 %@", self->_curUploadFileDataModel.filename, isSuccess ? @"成功":@"失败");
            }];
            
        }
        
        complete(YES);
    }];
    

}

//暂停上传完成
- (void)suspendUploadFileFun:(BOOL)isSuspendAll
{
//    if(isSuspendAll){
//
//    }
    
    _isSuspendType = YES;
    
    [[NSNotificationCenter defaultCenter] postNotificationName:uploadFileSuspendNotification object:nil];
}

//某个文件重新上传
- (void)reUploadFileFunBy:(uploadFileDataModel*)model
{
    _fileModelDataArr = [NSMutableArray new];
    [_fileModelDataArr addObject:model];
    [self beginUploadFileFun];
}

- (void)uploadFileDoneFun
{
    long totalSizeByte = [_curUploadFileDataModel.imageData length];
    
    if(_curUploadFileDataModel.curUploadFileType == uploadFileTypeVideo){
        totalSizeByte = [_curUploadFileDataModel.videoData length];
    }
    
    [self changeUploadFileState:uploadStateDone withDidUploadBytes:totalSizeByte complete:^(BOOL isSuccess) {
        [self->_fileModelDataArr removeObject:self->_curUploadFileDataModel];
         
        if(self->_fileModelDataArr.count > 0){
            [self beginUploadFileFun];
        }
    }];
}


//删除本地数据库记录
- (void)deleteUploadFileRecordBy:(NSMutableArray *)delArr complete:(custom_complete_B)complete
{
    //逻辑待优化
    BOOL isSuc = false;
    for (uploadFileDataModel *uploadFileDataMod in delArr) {
        
        NSMutableString* where = [[NSMutableString alloc] initWithString:@"where "];
        
        NSString *curStr =  [NSString stringWithFormat:@"%@=%@ ",bg_sqlKey(@"bg_id"),bg_sqlValue(uploadFileDataMod.bg_id)];
        [where appendString:curStr];
        isSuc = [uploadFileDataModel bg_delete:upLoadFile_image_tableName where:where];
    }
    
    complete(isSuc);
}

@end
